##############################################################
## MOD Title: phpBB Jabber Support
## MOD Author: ptlis <ptlis@ptlis.com> (Brian Ridley) http://www.ptlis.com
## MOD Description: Adds support for the Jabber IM network
## MOD Version: 1.0.5
##
## Installation Level: (Intermediate)
## Installation Time: 15 Minutes
## Files To Edit: viewtopic.php
##                language/lang_english/lang_main.php
##                admin/admin_users.php
##                includes/functions_validate.php
##                includes/usercp_avatar.php
##                includes/usercp_register.php
##                includes/usercp_viewprofile.php
##                templates/subSilver/admin/user_edit_body.tpl
##                templates/subSilver/SubSilver.cfg
##                templates/subSilver/profile_add_body.tpl
##                templates/subSilver/profile_view_body.tpl
##                templates/subSilver/viewtopic_body.tpl
## Included Files: icon_jabber_alt1.gif
##                 icon_jabber_alt2.gif
## License: http://opensource.org/licenses/gpl-license.php GNU General Public License v2
##############################################################
## For security purposes, please check: http://www.phpbb.com/mods/
## for the latest version of this MOD. Although MODs are checked
## before being allowed in the MODs Database there is no guarantee
## that there are no security problems within the MOD. No support
## will be given for MODs not found within the MODs Database which
## can be found at http://www.phpbb.com/mods/
##############################################################
## Author Notes:
##
##     This has been tested with phpBB 2.0.10 - 2.0.19 only, although I would
##     imagine it should install sucessfully on previous and/or future revisions
##     of the 2.0.xx release.
##
##     Two alternative images are included for the Jabber Icon for use with the
##     subSilver theme; rename the preferred image to icon_jabber.gif before you
##     install this mod.
##
##     In the /contrib/ directory you will find a 'meta-modification' that
##     allows you to use the XMPP:// URI with users' Jabber details.
##
##     The field for storing Jabber usernames is limited it to VARCHAR(255) - 
##     a rather conservative limit as the Jabber protocol has a limit of 1023
##     characters, and I can't find any information (generally or in the
##     RFCs/JEPs) as whether that's including the @domain.tld or not (in which
##     case it would be an extra 64 characters if one includes the '@' symbol.
##     The reason for this limitation is an attempt to minimize database bloat
##     because it would be extremely rare in practice to find a user with a
##     username greater than 256 characters.
##
##     This modification is Free software; you can redistribute it and/or
##     modify it under the terms of the GNU General Public License as published
##     by the Free Software Foundation; either version 2 of the License, or (at
##     your option) any later version.
##
##     http://www.fsf.org/licensing/licenses/gpl.html
##
##     Thanks goes to ian! <ian@gentoo.org> of http://www.iansview.com for
##     allowing me to modify/include the ACP modification he made.
##############################################################
## MOD History:
##
##   2004-08-19 - Version 0.0.1
##      - Initial release of this mod.
##
##   2004-09-17 - Version 0.0.2
##      - Fixed a language error and added border="0" to image tags so it's
##            standard with the SubSilver theme.
##
##   2004-10-06 - Version 0.0.3
##      - Minor change to make things more clear.
##
##   2004-12-26 - Version 0.0.4
##      - Fixed error to (hopefully) make this mod EasyMod compliant.
##      - Checked to ensure it works with phpBB 2.0.11.
##
##   2005-01-10 - Version 0.0.5
##      - Fixed error to (hopefully) make this mod EasyMod compliant (one more
##            error to go...).
##
##   2005-02-20 - Version 0.0.6
##      - Combined ACP section from ian!'s Jabber mod.
##      - Added missing copy statement.
##      - Cleaned up & standardised format of modification.
##
##   2005-02-22 - Version 1.0.0
##      - Clarified instructions relating to the jabber icon.
##      - Verified that this mod works with the phpBB 2.0.12 release.
##      - Initial submission to the Mod database.
##
##   2005-03-01 - Version 1.0.1
##      - Fixed MOD template issues flagged by the phpBB MOD validation team.
##
##   2005-08-23 - Version 1.0.2
##      - Cleaned up the larger find statements in the hopes that this will alow
##        this modification to integrate more seamlessly with boards that
##            contain other modifications.
##      - Verified that this mod works with the phpBB 2.0.17 release.
##
##   2005-09-11 - Version 1.0.3
##      - Updated the modification to conform to the new MOD template.
##
##   2005-09-15 - Version 1.0.4
##      - Fixed another issue so the MOD now conforms to the new MOD template.
##
##   2006-02-09 - Version 1.0.5
##      - Fixed an incompatibility introduced by the phpBB team when they
##            updated the codebase to 2.0.19
##
##############################################################
## Before Adding This MOD To Your Forum, You Should Back Up All Files Related To This MOD
##############################################################
#
#-----[ COPY ]------------------------------------------------
#
copy icon_jabber.gif to templates/subSilver/images/lang_english/icon_jabber.gif
#
#-----[ OPEN ]------------------------------------------------
#
viewtopic.php
#
#-----[ FIND ]------------------------------------------------
#
$sql = "SELECT u.username, u.user_id, u.user_posts,
#
#-----[ IN-LINE FIND ]----------------------------------------
#
, u.user_msnm
#
#-----[ IN-LINE AFTER, ADD ]----------------------------------
#
, u.user_jabber
#
#-----[ FIND ]------------------------------------------------
#
$msn = ( $postrow[$i]['user_msnm'] ) ? '<a href="' . $temp_url . '">' . $lang['MSNM'] . '</a>' : '';
#
#-----[ AFTER, ADD ]------------------------------------------
#
$jabber_img = ( $postrow[$i]['user_jabber'] ) ? '<a href="' . $temp_url . '"><img src="' . $images['icon_jabber'] . '" alt="' . $lang['JABBER'] . '" title="' . $lang['JABBER'] . '" border="0" /></a>' : '';
$jabber = ( $postrow[$i]['user_jabber'] ) ? '<a href="' . $temp_url . '">' . $lang['JABBER'] . '</a>' : '';
#
#-----[ FIND ]------------------------------------------------
#
$msn = '';
#
#-----[ AFTER, ADD ]------------------------------------------
#
$jabber_img = '';
$jabber = '';
#
#-----[ FIND ]------------------------------------------------
#
'MSN' => $msn,
#
#-----[ AFTER, ADD ]------------------------------------------
#
'JABBER_IMG' => $jabber_img,
'JABBER' => $jabber,
#
#-----[ OPEN ]------------------------------------------------
#
includes/functions_validate.php
#
#-----[ FIND ]------------------------------------------------
#
function validate_optional_fields(
#
#-----[ IN-LINE FIND ]----------------------------------------
#
, &$msnm
#
#-----[ IN-LINE AFTER, ADD ]----------------------------------
#
, &$jabber
#
#-----[ FIND ]------------------------------------------------
#
$check_var_length = array(
#
#-----[ IN-LINE FIND ]----------------------------------------
#
, 'msnm'
#
#-----[ IN-LINE AFTER, ADD ]----------------------------------
#
, 'jabber'
#
#-----[ OPEN ]------------------------------------------------
#
includes/usercp_avatar.php
#
#-----[ FIND ]------------------------------------------------
#
function display_avatar_gallery($mode, &$category, &$user_id, &$email,
#
#-----[ IN-LINE FIND ]----------------------------------------
#
, &$msn
#
#-----[ IN-LINE AFTER, ADD ]----------------------------------
#
, &$jabber
#
#-----[ FIND ]------------------------------------------------
#
$params = array('coppa', 'user_id', 'username', 'email', 'current_email',
#
#-----[ IN-LINE FIND ]----------------------------------------
#
, 'msn'
#
#-----[ IN-LINE AFTER, ADD ]----------------------------------
#
, 'jabber'
#
#-----[ OPEN ]------------------------------------------------
#
includes/usercp_register.php
#
#-----[ FIND ]------------------------------------------------
#
$strip_var_list = array(
#
#-----[ IN-LINE FIND ]----------------------------------------
#
, 'msn' => 'msn'
#
#-----[ IN-LINE AFTER, ADD ]----------------------------------
#
, 'jabber' => 'jabber'
#
#-----[ FIND ]------------------------------------------------
#
validate_optional_fields(
#
#-----[ IN-LINE FIND ]----------------------------------------
#
, $msn
#
#-----[ IN-LINE AFTER, ADD ]----------------------------------
#
, $jabber
#
#-----[ FIND ]------------------------------------------------
#
$msn = stripslashes($msn);
#
#-----[ AFTER, ADD ]------------------------------------------
#
$jabber = stripslashes($jabber);
#
#-----[ FIND ]------------------------------------------------
#
SET " . $username_sql . $passwd_sql . "user_email = '" . str_replace("\'", "''", $email) ."',
#
#-----[ IN-LINE FIND ]----------------------------------------
#
, user_msnm = '" . str_replace("\'", "''", $msn) . "'
#
#-----[ IN-LINE AFTER, ADD ]----------------------------------
#
, user_jabber = '" . str_replace("\'", "''", $jabber) . "'
#
#-----[ FIND ]------------------------------------------------
#
$sql = "INSERT INTO " . USERS_TABLE . "	(user_id, username, user_regdate, user_password, user_email, 
#
#-----[ IN-LINE FIND ]----------------------------------------
#
, user_msnm
#
#-----[ IN-LINE AFTER, ADD ]----------------------------------
#
, user_jabber
#
#-----[ FIND ]------------------------------------------------
#
VALUES ($user_id, '" . str_replace("\'", "''", $username) . "', " . time() . ", '" . str_replace("\'", "''", $new_password) . "', '" . str_replace("\'", "''", $email) . "',
#
#-----[ IN-LINE FIND ]----------------------------------------
#
, '" . str_replace("\'", "''", $msn) . "'
#
#-----[ IN-LINE AFTER, ADD ]----------------------------------
#
, '" . str_replace("\'", "''", $jabber) . "'
#
#-----[ FIND ]------------------------------------------------
#
'MSN' => $msn,
#
#-----[ AFTER, ADD ]------------------------------------------
#
'JABBER' => $jabber,
#
#-----[ FIND ]------------------------------------------------
#
$msn = stripslashes($msn);
#
#-----[ AFTER, ADD ]------------------------------------------
#
$jabber = stripslashes($jabber);
#
#-----[ FIND ]------------------------------------------------
#
$msn = $userdata['user_msnm'];
#
#-----[ AFTER, ADD ]------------------------------------------
#
$jabber = $userdata['user_jabber'];
#
#-----[ FIND ]------------------------------------------------
#
display_avatar_gallery($mode, $avatar_category, $user_id, $email, $current_email,
#
#-----[ IN-LINE FIND ]----------------------------------------
#
, $msn
#
#-----[ IN-LINE AFTER, ADD ]----------------------------------
#
, $jabber
#
#-----[ FIND ]------------------------------------------------
#
'MSN' => $msn,
#
#-----[ AFTER, ADD ]------------------------------------------
#
'JABBER' => $jabber,
#
#-----[ FIND ]------------------------------------------------
#
'L_MESSENGER' => $lang['MSNM'],
#
#-----[ AFTER, ADD ]------------------------------------------
#
'L_JABBER' => $lang['JABBER'],
#
#-----[ OPEN ]------------------------------------------------
#
includes/usercp_viewprofile.php
#
#-----[ FIND ]------------------------------------------------
#
$msn = $msn_img;
#
#-----[ AFTER, ADD ]------------------------------------------
#
$jabber_img = ( $profiledata['user_jabber'] ) ? $profiledata['user_jabber'] : '&nbsp;';
$jabber = $jabber_img;
#
#-----[ FIND ]------------------------------------------------
#
'MSN' => $msn,
#
#-----[ AFTER, ADD ]------------------------------------------
#
'JABBER_IMG' => $jabber_img,
'JABBER' => $jabber,
#
#-----[ FIND ]------------------------------------------------
#
'L_MESSENGER' => $lang['MSNM'],
#
#-----[ AFTER, ADD ]------------------------------------------
#
'L_JABBER' => $lang['JABBER'],
#
#-----[ OPEN ]------------------------------------------------
#
language/lang_english/lang_main.php
#
#-----[ FIND ]------------------------------------------------
#
$lang['MSNM'] = 'MSN Messenger';
#
#-----[ AFTER, ADD ]------------------------------------------
#
$lang['JABBER'] = 'Jabber';
#
#-----[ OPEN ]------------------------------------------------
#
admin/admin_users.php
#
#-----[ FIND ]------------------------------------------------
#
$msn = ( !empty($HTTP_POST_VARS['msn']) ) ? trim(strip_tags( $HTTP_POST_VARS['msn'] ) ) : '';
#
#-----[ AFTER, ADD ]------------------------------------------
#
$jabber = ( !empty($HTTP_POST_VARS['jabber']) ) ? trim(strip_tags( $HTTP_POST_VARS['jabber'] ) ) : '';
#
#-----[ FIND ]------------------------------------------------
#
validate_optional_fields(
#
#-----[ IN-LINE FIND ]----------------------------------------
#
, $msn
#
#-----[ IN-LINE AFTER, ADD ]----------------------------------
#
, $jabber
#
#-----[ FIND ]------------------------------------------------
#
$msn = htmlspecialchars(stripslashes($msn));
#
#-----[ AFTER, ADD ]------------------------------------------
#
$jabber = htmlspecialchars(stripslashes($jabber));
#
#-----[ FIND ]------------------------------------------------
#
SET " . $username_sql . $passwd_sql . "user_email = '" . str_replace("\'", "''", $email) . "',
#
#-----[ IN-LINE FIND ]----------------------------------------
#
, user_msnm = '" . str_replace("\'", "''", $msn) . "'
#
#-----[ IN-LINE AFTER, ADD ]----------------------------------
#
, user_jabber = '" . str_replace("\'", "''", $jabber) . "'
#
#-----[ FIND ]------------------------------------------------
#
$msn = htmlspecialchars(stripslashes($msn));
#
#-----[ AFTER, ADD ]------------------------------------------
#
$jabber = htmlspecialchars(stripslashes($jabber));
#
#------[ FIND ]-----------------------------------------------
#
$msn = htmlspecialchars($this_userdata['user_msnm']);
#
#------[ AFTER, ADD ]-----------------------------------------
#
$jabber = htmlspecialchars($this_userdata['user_jabber']);
#
#-----[ FIND ]------------------------------------------------
#
$s_hidden_fields .= '<input type="hidden" name="msn" value="' . str_replace("\"", "&quot;", $msn) . '" />';
#
#-----[ AFTER, ADD ]------------------------------------------
#
$s_hidden_fields .= '<input type="hidden" name="jabber" value="' . str_replace("\"", "&quot;", $jabber) . '" />';
#
#-----[ FIND ]------------------------------------------------
#
'MSN' => $msn,
#
#-----[ AFTER, ADD ]------------------------------------------
#
'JABBER' => $jabber,
#
#-----[ FIND ]------------------------------------------------
#
'L_MESSENGER' => $lang['MSNM'],
#
#-----[ AFTER, ADD ]------------------------------------------
#
'L_JABBER' => $lang['JABBER'],
#
#-----[ OPEN ]------------------------------------------------
#
templates/subSilver/subSilver.cfg
#
#-----[ FIND ]------------------------------------------------
#
$images['icon_msnm'] = "$current_template_images/{LANG}/icon_msnm.gif";
#
#-----[ AFTER, ADD ]------------------------------------------
#
$images['icon_jabber'] = "$current_template_images/{LANG}/icon_jabber.gif";
#
#-----[ OPEN ]------------------------------------------------
#
templates/subSilver/profile_add_body.tpl
#
#-----[ FIND ]------------------------------------------------
#
   <tr>
     <td class="row1"><span class="gen">{L_MESSENGER}:</span></td>
     <td class="row2">
      <input type="text" class="post"style="width: 150px"  name="msn" size="20" maxlength="255" value="{MSN}" />
     </td>
   </tr>
#
#-----[ AFTER, ADD ]------------------------------------------
#
   <tr>
     <td class="row1"><span class="gen">{L_JABBER}:</span></td>
     <td class="row2">
      <input type="text" class="post"style="width: 150px"  name="jabber" size="20" maxlength="255" value="{JABBER}" />
     </td>
   </tr>
#
#-----[ OPEN ]------------------------------------------------
#
templates/subSilver/profile_view_body.tpl
#
#-----[ FIND ]------------------------------------------------
#
      <tr>
        <td valign="middle" nowrap="nowrap" align="right"><span class="gen">{L_MESSENGER}:</span></td>
        <td class="row1" valign="middle"><span class="gen">{MSN}</span></td>
      </tr>
#
#-----[ AFTER, ADD ]------------------------------------------
#
      <tr>
        <td valign="middle" nowrap="nowrap" align="right"><span class="gen">{L_JABBER}:</span></td>
        <td class="row1" valign="middle"><span class="gen">{JABBER}</span></td>
      </tr>
#
#-----[ OPEN ]------------------------------------------------
#
templates/subSilver/viewtopic_body.tpl
#
#-----[ FIND ]------------------------------------------------
#
<td valign="middle" nowrap="nowrap">{postrow.PROFILE_IMG} {postrow.PM_IMG}
#
#-----[ IN-LINE FIND ]----------------------------------------
#
{postrow.MSN_IMG}
#
#
#-----[ IN-LINE AFTER, ADD ]----------------------------------
#
 {postrow.JABBER_IMG}
#
#-----[ OPEN ]------------------------------------------------
#
templates/subSilver/admin/user_edit_body.tpl
#
#-----[ FIND ]------------------------------------------------
#
    <tr>
      <td class="row1"><span class="gen">{L_MESSENGER}</span></td>
      <td class="row2">
        <input class="post" type="text" name="msn" size="20" maxlength="255" value="{MSN}" />
      </td>
    </tr>
#
#-----[ AFTER, ADD ]------------------------------------------
#
    <tr>
      <td class="row1"><span class="gen">{L_JABBER}</span></td>
      <td class="row2">
        <input class="post" type="text" name="jabber" size="20" maxlength="255" value="{JABBER}" />
      </td>
    </tr>
#
#-----[ SQL ]-------------------------------------------------
#
ALTER TABLE `phpbb_users` ADD `user_jabber` VARCHAR( 255 ) DEFAULT NULL;
#
#-----[ SAVE/CLOSE ALL FILES ]--------------------------------
#
# EoM
